/**
 * Super IsoBomb
 *
 * Authors: Jim Clase, Jonathan Hilliker, Jason Winnebeck
 */

#ifndef ENDGAME_H_PWK402
#define ENDGAME_H_PWK402

#include "GameLogic.h"
class ConfigFile;

/**
 * The EndGame object ends the game by calling resetMap on the global Game
 * object when time runs out.
 */
class EndGame : public GameLogic {
public:
    /**
     * Initializes the default timeToReset from information in the ConfigFile.
     */
    static void initTimeToReset( ConfigFile& f );

    /**
     * Constructs the EndGame with a default timeToReset.
     */
    EndGame();

    /**
     * Constructs the EndGame to end the game after the given amount of time.
     */
    explicit EndGame( float timeToReset );

    /**
     * Destructor.
     */
    virtual ~EndGame();

    /**
     * Update counts down the time left.  Restarts the game after time runs
     * out.
     */
    bool update( float dt );

private:
    static float defaultTimeToReset;

    float timeLeft;
};

#endif
