/**
 * Super IsoBomb
 *
 * Authors: Jim Clase, Jonathan Hilliker, Jason Winnebeck
 */

#include "Entity.h"
#include "Character.h"
#include "Explosion.h"
#include "Game.h"

Entity::Entity() : direction(0) {

}

Entity::Entity( const Rect& initPos, int initDir ) : 
    pos(initPos), direction(initDir) {

}

Entity::~Entity() {

}

bool Entity::checkCollision( const Entity* otherEntity ) {
    if ( pos.isCollision( otherEntity->pos ) ) {
        float diff = fabsf( this->getHeight() - otherEntity->getHeight() );
        return (diff <= 3.0f);
    } else
        return false;
}

void Entity::doCollision( Entity* otherEntity ) {
    // Do nothing
}

const Rect& Entity::getPosition() const {
    return pos;
}

int Entity::getDirection() const {
    return direction;
}

void Entity::reverseDirection() {
    switch( direction ) {
    case DIRECTION_DOWNRIGHT:
        direction = DIRECTION_UPLEFT;
        break;
    case DIRECTION_UPLEFT:
        direction = DIRECTION_DOWNRIGHT;
        break;
    case DIRECTION_UPRIGHT:
        direction = DIRECTION_DOWNLEFT;
        break;
    case DIRECTION_DOWNLEFT:
        direction = DIRECTION_UPRIGHT;
        break;
    }
}