/**
 * Super IsoBomb
 *
 * Authors: Jim Clase, Jonathan Hilliker, Jason Winnebeck
 */

#ifndef GAMELOGIC_H_KWE9123
#define GAMELOGIC_H_KWE9123

/**
 * A GameLogic class is a an updated object within the game.  It does not have
 * an "existance" within the game like an Entity does.  A GameLogic is updated
 * and has a lifetime, but it does not get considered in the input or draw
 * cycles.
 *
 * GameLogic is an abstract base class with no implementation file.
 */
class GameLogic {
public:
    GameLogic() {}

    virtual ~GameLogic() {}

    /**
     * Updates the logic to this object.  Returns true when the lifetime of
     * this object has ended, and it wants to be deleted.
     *
     * @param dt                the amount of time since the last frame
     * @returns                 true if this GameLogic's life has ended
     */
    virtual bool update( float dt ) = 0;
private:
};

#endif
