#include "IsoBomb.h"

/**
 * Super IsoBomb
 *
 * Authors: Jim Clase, Jonathan Hilliker, Jason Winnebeck
 */

#include "IsoException.h"

IsoException::IsoException() : msg("unknown error") {
}

IsoException::IsoException( const std::string& msg ) : msg(msg) {
}

void IsoException::showMessageBox() const {
    HWND hWnd = NULL;
    if ( g_win != NULL )
        hWnd = g_win->getHwnd();

    MessageBox( hWnd, msg.c_str(), "Super IsoBomb Error", MB_OK | MB_ICONWARNING );
}

const std::string& IsoException::getMessage() const {
    return msg;
}
