/**
 * Super IsoBomb
 *
 * Authors: Jim Clase, Jonathan Hilliker, Jason Winnebeck
 */

#include "IsoBomb.h"

#ifndef ISOEXCEPTION_H_DFWER234
#define ISOEXCEPTION_H_DFWER234

/**
 * The IsoException is the base class for exceptions in Super IsoBomb.
 */
class IsoException {
public:
    /**
     * Creates a new exception with the message "unknown error".
     */
    IsoException();

    /**
     * Creates a new exception with the specified message.
     */
    explicit IsoException( const std::string& msg );

    /**
     * Displays an appropriate message box to the user containing this
     * exception's message.
     */
    void showMessageBox() const;

    /**
     * Returns this exception's message string.
     */
    const std::string& getMessage() const;

private:
    std::string msg;
};

#endif //#ifdef ISOEXCEPTION_H_DFWER234
