/**
 * Super IsoBomb
 *
 * Authors: Jim Clase, Jonathan Hilliker, Jason Winnebeck
 */

#include "Vector.h"

//using namespace std;

void Vector::initRect(float magx2, float magy2) {
  magx = magx2;
  magy = magy2;
  theta = (float)(atan2(magy, magx));
  mag = (float)sqrt( magx * magx + magy * magy );
  /*
  if (magy)
    mag = magy / (float)sin(theta);
  else
    mag = (float)fabs(magx);
  */
  assert(mag >= 0.0);
}

void Vector::initPolar(float theta2, float mag2) {
  assert( mag2 >= 0 );
  theta = theta2;
  mag = mag2;
  magy = mag * (float)sin(theta);
  magx = mag * (float)cos(theta);
}

void Vector::rotate(float rotation) {
  assert(mag >= 0.0);
  /*theta += rotation;
  magy = mag * sin(theta);
  magx = mag * cos(theta);*/
	setTheta( theta + rotation );
}

void Vector::add(const Vector& other) {
  //Vector addition
  initRect(magx+other.magx, magy+other.magy);
}

void Vector::add(float scalar) {
  assert(mag >= 0.0);
  mag += scalar;
  magy = mag * (float)sin(theta);
  magx = mag * (float)cos(theta);
  assert(mag >= 0.0);
}

void Vector::clip(float max) {
  assert(mag >= 0.0);
  //Adds to total magnitude
	if( max > 0 ) {
	  if (mag > max) {
		mag = max;
		magy = mag * (float)sin(theta);
		magx = mag * (float)cos(theta);
	  }
	}
	else {
	  if (mag < max) {
		mag = max;
		magy = mag * (float)sin(theta);
		magx = mag * (float)cos(theta);
	  }
	}
  assert(mag >= 0.0);
}

/*
void Vector::clipTheta(double newTheta, double tolerance) {
  if (theta != newTheta) {
    if (abs(theta - newTheta) < tolerance)
      theta = newTheta;
      magy = mag * sin(theta);
      magx = mag * cos(theta);
  }
}

*/
void Vector::mult(float scalar) {
  assert(mag >= 0.0);
  //multiplies to total magnitude
  mag *= scalar;
  magy *= scalar;
  magx *= scalar;
  assert(mag >= 0.0);
}

void Vector::setTheta( float rot ) {
  assert(mag >= 0.0);
	theta = rot;
	magy = mag * (float)sin(theta);
	magx = mag * (float)cos(theta);
  assert(mag >= 0.0);
}